' Make shortcut on Desktop and Set as Run As Admin

Q = chr(34)
dim fso
dim curDir
dim WinScriptHost

If WScript.Arguments.Count < 2 Then 
	wscript.echo "Please run CreateShortcuts.cmd"
	wscript.quit
End if

' --- SET Target and Desktop Link Name from command line ---

strTargetName = WScript.Arguments.Item(0) 
strLinkName = WScript.Arguments.Item(1)

'Target - e.g.    %windir%\system32\cmd.exe /c C:\"temp\MakePartImage_AutoRun_FAT32.cmd"

set WshShell = CreateObject("WScript.Shell")
set fso = CreateObject("Scripting.FileSystemObject")
strWinDir =WshShell.ExpandEnvironmentStrings("%windir%")
strSysDir = strWinDir & "\System32"
strMyDir = fso.GetParentFolderName(wscript.ScriptFullName) 
strDesktop = WshShell.SpecialFolders("Desktop")
strCurDir = WshShell.CurrentDirectory   ' e.g. C:\temp

strMyDirSpecial = Mid(strMyDir,1,3) & Q & Mid(strMyDir,4) & "\" & strTargetName & Q
set oMyShortCut= WshShell.CreateShortcut(strDesktop+"\" & strLinkName)
oMyShortCut.WindowStyle = 1  							'1=default 3=max  7=Min
oMyShortCut.TargetPath = Q & strSysDir & "\cmd.exe"  & Q
oMyShortCut.Arguments=  " /c " & strMyDirSpecial
oMyShortcut.IconLocation = "%windir%\system32\cmd.exe"
oMyShortCut.WorkingDirectory = Q & strMyDir & Q
oMyShortCut.Save
set fso = nothing

' --- PATCH .LNK FILE to set byte 21 bit 5  for Admin rights
Dim  data
data = ReadBinary(strDesktop+"\" & strLinkName)
'wscript.echo "BYTES 20-23 " & hex(asc(mid(data,20,1))) & " " & hex(asc(mid(data,21,1))) & " " & hex(asc(mid(data,22,1))) & " " & hex(asc(mid(data,23,1)))
dim b21
b21 = asc(mid(data,22,1)) or 32	'set bit 6  0x20
'b21 = b21 or 32
data = mid(data,1,21) & chr(b21) & mid(data,23)
'wscript.echo "BYTES 20-23 " & hex(asc(mid(data,20,1))) & " " & hex(asc(mid(data,21,1))) & " " & hex(asc(mid(data,22,1))) & " " & hex(asc(mid(data,23,1)))
WriteBinary data,strDesktop+"\" & strLinkName

wscript.echo "Shortcut " & strLinkName & " created on Desktop."

' ------------------ END -------------------------

Function readBinary(path)
Dim a, fso, file, i, ts
Set fso = CreateObject("Scripting.FileSystemObject")
Set file = fso.getFile(path)
If isNull(file) Then
    MsgBox("File not found: " & path)
    Exit Function
End If
Set ts = file.OpenAsTextStream()
a = makeArray(file.size)
i = 0
' Do not replace the following block by readBinary = by ts.readAll(), it would result in broken output, because that method is not intended for binary data 
While Not ts.atEndOfStream
    a(i) = ts.read(1)
i = i + 1
Wend
ts.close
readBinary = Join(a,"")
End Function

Sub writeBinary(bstr, path)
Dim fso
Dim ts
Set fso = CreateObject("Scripting.FileSystemObject")
On Error Resume Next
Set ts = fso.createTextFile(path)
If Err.number <> 0 Then
    MsgBox(Err.message)
    Exit Sub
End If
On Error GoTo 0
ts.Write(bstr)
ts.Close
End Sub

Function makeArray(n) ' Small utility function
Dim s
s = Space(n)
makeArray = Split(s," ")
End Function



